# coding: utf-8

"""

    # Authentication  <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 0.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from apifff.api_client import ApiClient


class PouleApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def api_compets_phases_poules_classement_journees_get_subresource_compet_subresource(self, cp_no, phases, poules, **kwargs):  # noqa: E501
        """Retrieves a Compet resource.  # noqa: E501

        Retrieves a Compet resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_compets_phases_poules_classement_journees_get_subresource_compet_subresource(cp_no, phases, poules, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cp_no: Compet identifier (required)
        :param str phases: Phase identifier (required)
        :param str poules: Poule identifier (required)
        :return: InlineResponse20013
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_compets_phases_poules_classement_journees_get_subresource_compet_subresource_with_http_info(cp_no, phases, poules, **kwargs)  # noqa: E501
        else:
            (data) = self.api_compets_phases_poules_classement_journees_get_subresource_compet_subresource_with_http_info(cp_no, phases, poules, **kwargs)  # noqa: E501
            return data

    def api_compets_phases_poules_classement_journees_get_subresource_compet_subresource_with_http_info(self, cp_no, phases, poules, **kwargs):  # noqa: E501
        """Retrieves a Compet resource.  # noqa: E501

        Retrieves a Compet resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_compets_phases_poules_classement_journees_get_subresource_compet_subresource_with_http_info(cp_no, phases, poules, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cp_no: Compet identifier (required)
        :param str phases: Phase identifier (required)
        :param str poules: Poule identifier (required)
        :return: InlineResponse20013
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cp_no', 'phases', 'poules']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_compets_phases_poules_classement_journees_get_subresource_compet_subresource" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cp_no' is set
        if ('cp_no' not in params or
                params['cp_no'] is None):
            raise ValueError("Missing the required parameter `cp_no` when calling `api_compets_phases_poules_classement_journees_get_subresource_compet_subresource`")  # noqa: E501
        # verify the required parameter 'phases' is set
        if ('phases' not in params or
                params['phases'] is None):
            raise ValueError("Missing the required parameter `phases` when calling `api_compets_phases_poules_classement_journees_get_subresource_compet_subresource`")  # noqa: E501
        # verify the required parameter 'poules' is set
        if ('poules' not in params or
                params['poules'] is None):
            raise ValueError("Missing the required parameter `poules` when calling `api_compets_phases_poules_classement_journees_get_subresource_compet_subresource`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cp_no' in params:
            path_params['cpNo'] = params['cp_no']  # noqa: E501
        if 'phases' in params:
            path_params['phases'] = params['phases']  # noqa: E501
        if 'poules' in params:
            path_params['poules'] = params['poules']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/compets/{cpNo}/phases/{phases}/poules/{poules}/classement_journees', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20013',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_compets_phases_poules_get_subresource_compet_subresource(self, cp_no, phases, **kwargs):  # noqa: E501
        """Retrieves a Compet resource.  # noqa: E501

        Retrieves a Compet resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_compets_phases_poules_get_subresource_compet_subresource(cp_no, phases, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cp_no: Compet identifier (required)
        :param str phases: Phase identifier (required)
        :param int gp_no:
        :param list[int] gp_no:
        :return: InlineResponse20012
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_compets_phases_poules_get_subresource_compet_subresource_with_http_info(cp_no, phases, **kwargs)  # noqa: E501
        else:
            (data) = self.api_compets_phases_poules_get_subresource_compet_subresource_with_http_info(cp_no, phases, **kwargs)  # noqa: E501
            return data

    def api_compets_phases_poules_get_subresource_compet_subresource_with_http_info(self, cp_no, phases, **kwargs):  # noqa: E501
        """Retrieves a Compet resource.  # noqa: E501

        Retrieves a Compet resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_compets_phases_poules_get_subresource_compet_subresource_with_http_info(cp_no, phases, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cp_no: Compet identifier (required)
        :param str phases: Phase identifier (required)
        :param int gp_no:
        :param list[int] gp_no:
        :return: InlineResponse20012
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cp_no', 'phases', 'gp_no', 'gp_no']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_compets_phases_poules_get_subresource_compet_subresource" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cp_no' is set
        if ('cp_no' not in params or
                params['cp_no'] is None):
            raise ValueError("Missing the required parameter `cp_no` when calling `api_compets_phases_poules_get_subresource_compet_subresource`")  # noqa: E501
        # verify the required parameter 'phases' is set
        if ('phases' not in params or
                params['phases'] is None):
            raise ValueError("Missing the required parameter `phases` when calling `api_compets_phases_poules_get_subresource_compet_subresource`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cp_no' in params:
            path_params['cpNo'] = params['cp_no']  # noqa: E501
        if 'phases' in params:
            path_params['phases'] = params['phases']  # noqa: E501

        query_params = []
        if 'gp_no' in params:
            query_params.append(('gp_no', params['gp_no']))  # noqa: E501
        if 'gp_no' in params:
            query_params.append(('gp_no[]', params['gp_no']))  # noqa: E501
            collection_formats['gp_no[]'] = 'multi'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/compets/{cpNo}/phases/{phases}/poules', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20012',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def api_compets_phases_poules_poule_journees_get_subresource_compet_subresource(self, cp_no, phases, poules, **kwargs):  # noqa: E501
        """Retrieves a Compet resource.  # noqa: E501

        Permet de récupérer les journées d'une poule. Par défaut les matchs ne sont pas retournés. Pour avoir les matchs, ajouter `pouleJourneeWithMatch` dans le champs `details[]`. Attention passer ce paramètre sans filtre sur `pj_no` peut retourner une erreur (pour cause de requête trop volumineuse)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_compets_phases_poules_poule_journees_get_subresource_compet_subresource(cp_no, phases, poules, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cp_no: Compet identifier (required)
        :param str phases: Phase identifier (required)
        :param str poules: Poule identifier (required)
        :param int pj_no:
        :param list[int] pj_no:
        :param list[str] details:
        :return: InlineResponse20014
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_compets_phases_poules_poule_journees_get_subresource_compet_subresource_with_http_info(cp_no, phases, poules, **kwargs)  # noqa: E501
        else:
            (data) = self.api_compets_phases_poules_poule_journees_get_subresource_compet_subresource_with_http_info(cp_no, phases, poules, **kwargs)  # noqa: E501
            return data

    def api_compets_phases_poules_poule_journees_get_subresource_compet_subresource_with_http_info(self, cp_no, phases, poules, **kwargs):  # noqa: E501
        """Retrieves a Compet resource.  # noqa: E501

        Permet de récupérer les journées d'une poule. Par défaut les matchs ne sont pas retournés. Pour avoir les matchs, ajouter `pouleJourneeWithMatch` dans le champs `details[]`. Attention passer ce paramètre sans filtre sur `pj_no` peut retourner une erreur (pour cause de requête trop volumineuse)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_compets_phases_poules_poule_journees_get_subresource_compet_subresource_with_http_info(cp_no, phases, poules, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str cp_no: Compet identifier (required)
        :param str phases: Phase identifier (required)
        :param str poules: Poule identifier (required)
        :param int pj_no:
        :param list[int] pj_no:
        :param list[str] details:
        :return: InlineResponse20014
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cp_no', 'phases', 'poules', 'pj_no', 'pj_no', 'details']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_compets_phases_poules_poule_journees_get_subresource_compet_subresource" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cp_no' is set
        if ('cp_no' not in params or
                params['cp_no'] is None):
            raise ValueError("Missing the required parameter `cp_no` when calling `api_compets_phases_poules_poule_journees_get_subresource_compet_subresource`")  # noqa: E501
        # verify the required parameter 'phases' is set
        if ('phases' not in params or
                params['phases'] is None):
            raise ValueError("Missing the required parameter `phases` when calling `api_compets_phases_poules_poule_journees_get_subresource_compet_subresource`")  # noqa: E501
        # verify the required parameter 'poules' is set
        if ('poules' not in params or
                params['poules'] is None):
            raise ValueError("Missing the required parameter `poules` when calling `api_compets_phases_poules_poule_journees_get_subresource_compet_subresource`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cp_no' in params:
            path_params['cpNo'] = params['cp_no']  # noqa: E501
        if 'phases' in params:
            path_params['phases'] = params['phases']  # noqa: E501
        if 'poules' in params:
            path_params['poules'] = params['poules']  # noqa: E501

        query_params = []
        if 'pj_no' in params:
            query_params.append(('pj_no', params['pj_no']))  # noqa: E501
        if 'pj_no' in params:
            query_params.append(('pj_no[]', params['pj_no']))  # noqa: E501
            collection_formats['pj_no[]'] = 'multi'  # noqa: E501
        if 'details' in params:
            query_params.append(('details[]', params['details']))  # noqa: E501
            collection_formats['details[]'] = 'multi'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/compets/{cpNo}/phases/{phases}/poules/{poules}/poule_journees', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20014',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
